//=============================================================================  
//  Edité par le créateur de plugin MuseScore
//  
//  Pour tablature d'accordéon diatonique
//  Cette version est conçue pour un accordéon Castagnéri en Sol/Do (de la note MIDI50 à la note MIDI88)
//  Elle peut être utilisée pour d'autres tonalités par transposition
//
//  Ce programme est largement inspiré de celui publié par Joachim Schmitz (Copyright 2012)
//  Ainsi que les nombreux contributeurs qui ont proposé leurs propres adaptations
//
//  Pour tout le blablabla habituel concernant les droits d'auteur et les garanties légales, reportez vous
//  au texte initial et aux termes de license publique GNU.(en anglais, bien sur !)
//=============================================================================
// Michel Come (Novembre 2019)

import QtQuick 2.0
import MuseScore 3.0


MuseScore {
   version: "3.0"
   description: "Tablature d'accordéon diatonique"
   menuPath: 'Plugins.Tablature pour diato'
   onRun: {
      if (typeof curScore === 'undefined')
         Qt.quit();

      // Liste des boutons correspondant à chaque note ( en partant de Ré MIDI50). 
      // Si deux boutons sont possibles, mettre \n entre eux pour afficher l'un au dessous de l'autre
      var maindroite = [ 
         " \n \n2\n1\n ",     // Ré       50
         " ",                 // Ré# Mib  51
         " \n \n1'",          // Mi       52
         " ",                 // Fa       53
         " \n \n \n2\n ",     // Fa# Solb 54
         " \n3\n2'\n1'\n ",   // Sol      55
         " ",                 // Sol# Lab 56
         " \n \n \n3\n ",     // La       57
         " ",                 // La# Sib  58
         " \ \n4\n2'\n ",     // Si       59
         " \n \n3'\n4\n ",    // Do       60
         " \n \n \n1''\n ",   // Do# Réb  61 
         " \n \n5\n3'\n ",    // Ré       62
         " \n \n1''",         // Ré# Mib  63
         " \n \n4'\n5\n ",    // Mi       64
         " \n \n \n4'\n",     // Fa       65
         " \n \n \n6\n ",     // Fa# Solb 66
         " \n6\n5'",          // Sol      67
         " \n \n2''",         // Sol# Lab 68
         " \n \n \n7\n5'",    // La       69
         " \n \n \n2''\n ",   // La# Sib  70
         " \n \n7\n6'\n ",    // Si       71
         " \n \n6'\n8\n ",    // Do       72
         " \n \n \n3''\n ",   // Do# Réb  73
         " \n \n8\n7'\n ",    // Ré       74
         " \n \n3''",         // Ré# Mib  75    
         " \n \n7'\n9\n ",    // Mi       76
         " \n \n \n8'\n ",    // Fa       77
         " \n \n \n10\n ",    // Fa# Solb 78
         " \n8'\n9\n ",       // Sol      79
         " \n \n4''",         // Sol# Lab 80
         " \n \n \n9'\n11",   // La       81
         " \n \n \n4''\n ",   // La# Sib  82
         " \n \n10\n10'\n ",  // Si       83
         " \n \n9'",          // Do       84
         " ",                 // Do# Réb  85
         " \n \n11",          // Ré       86
         " ",                 // Ré# Mib  87
         " \n \n10'",         // Mi       88
      ]; 

      var cursor = curScore.newCursor();

      for (var staff = 0; staff < curScore.nstaves; ++staff) {
         cursor.staffIdx = staff;
         cursor.voice = 0;
         cursor.rewind(0);  // Set cursor to first chord/rest
         while (cursor.segment) {
            if (cursor.element && cursor.element.type == Element.CHORD) {
               var pitch = cursor.element.notes[0].pitch;
               var indice = pitch - 50;

               if (indice >= 0 && indice < maindroite.length)
                { 
               //Main droite
                  var Numéro = newElement(Element.STAFF_TEXT);
                  //var font = new QFont("Arial", 13); ca plante                    
                  //Numéro.defaultFont = font;
                  Numéro.text = maindroite[indice];
                  Numéro.placement = 1 ;
                  Numéro.autoplace = false ;
                  //Numéro.offsetY = 18.5 ; ça marche pas !
                  cursor.add(Numéro);
                }
            }
            cursor.next();
         }
      }
      Qt.quit();
   }
}
